=== mondo/distributions/debian/changelog ===
mondo (2.11r301-1) unstable; urgency=low

  * Initial Release.

 -- Bruno Cornec <bcornec@users.berlios.de>  Thu, 12 Jan 2006 20:52:16 +1100
