=== mondo/distributions/debian/control ===
Source: mondo
Section: utils
Priority: optional
Maintainer: Hector Garcia <hector@debian.org>
Build-Depends: debhelper (>= 4.2.20), libnewt-dev, libncurses5-dev
Standards-Version: 3.6.2
Uploaders: Andree Leidenfrost <aleidenf@bigpond.net.au>, Amaya Rodrigo Sastre <amaya@debian.org>

Package: mondo
Architecture: i386
Section: utils
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, mindi (>= 1.06), binutils, afio, buffer, gawk, cdrecord, lzop, dosfstools
Recommends: dvd+rw-tools
Suggests: mondo-doc
Description: powerful disaster recovery suite
 Mondo is reliable. It backs up your Debian GNU/Linux server or workstation to
 tape, CD-R, CD-RW, NFS or hard disk partition. In the event of catastrophic
 data loss, you will be able to restore all of your data [or as much as you
 want], from bare metal if necessary. Mondo is in use by numerous blue-chip
 enterprises and large organizations, dozens of smaller companies, and tens of
 thousands of users.
 .
 Mondo is comprehensive. Mondo supports LVM, RAID, ext2, ext3, JFS, XFS,
 ReiserFS, VFAT, and can support additional file systems easily. It supports
 adjustments in disk geometry, including migration from non-RAID to RAID. Mondo
 runs on all major Linux distributions and is getting better all the time. You
 may even use it to backup non-Linux partitions, such as NTFS.
 .
 IMPORTANT NOTE: This is the uostream version of mondo. Please do not report
 bug to Debian's Bug Tracking System.
 .
 Homepage: http://www.mondorescue.org

Package: mondo-doc
Architecture: all
Section: doc
Priority: optional
Suggests: mondo
Description: manual for Mondo, a powerful disaster recovery suite
 Mondo is reliable. It backs up your Debian GNU/Linux server or workstation to
 tape, CD-R, CD-RW, NFS or hard disk partition. In the event of catastrophic
 data loss, you will be able to restore all of your data [or as much as you
 want], from bare metal if necessary. Mondo is in use by numerous blue-chip
 enterprises and large organizations, dozens of smaller companies, and tens of
 thousands of users.
 .
 Mondo is comprehensive. Mondo supports LVM, RAID, ext2, ext3, JFS, XFS,
 ReiserFS, VFAT, and can support additional file systems easily. It supports
 adjustments in disk geometry, including migration from non-RAID to RAID. Mondo
 runs on all major Linux distributions and is getting better all the time. You
 may even use it to backup non-Linux partitions, such as NTFS.
 .
 IMPORTANT NOTE: This is the uostream version of mondo. Please do not report
 bug to Debian's Bug Tracking System.
 .
 Homepage: http://www.mondorescue.org
